# coding: utf-8

"""
    FlexPrice API

    FlexPrice API Service

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from flexprice.models.dto_billing_period_info import DtoBillingPeriodInfo
from flexprice.models.dto_feature_usage_summary import DtoFeatureUsageSummary
from flexprice.models.types_pagination_response import TypesPaginationResponse
from typing import Optional, Set
from typing_extensions import Self

class DtoCustomerUsageSummaryResponse(BaseModel):
    """
    DtoCustomerUsageSummaryResponse
    """ # noqa: E501
    customer_id: Optional[StrictStr] = None
    features: Optional[List[DtoFeatureUsageSummary]] = None
    pagination: Optional[TypesPaginationResponse] = None
    period: Optional[DtoBillingPeriodInfo] = None
    __properties: ClassVar[List[str]] = ["customer_id", "features", "pagination", "period"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DtoCustomerUsageSummaryResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in features (list)
        _items = []
        if self.features:
            for _item_features in self.features:
                if _item_features:
                    _items.append(_item_features.to_dict())
            _dict['features'] = _items
        # override the default output from pydantic by calling `to_dict()` of pagination
        if self.pagination:
            _dict['pagination'] = self.pagination.to_dict()
        # override the default output from pydantic by calling `to_dict()` of period
        if self.period:
            _dict['period'] = self.period.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DtoCustomerUsageSummaryResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customer_id": obj.get("customer_id"),
            "features": [DtoFeatureUsageSummary.from_dict(_item) for _item in obj["features"]] if obj.get("features") is not None else None,
            "pagination": TypesPaginationResponse.from_dict(obj["pagination"]) if obj.get("pagination") is not None else None,
            "period": DtoBillingPeriodInfo.from_dict(obj["period"]) if obj.get("period") is not None else None
        })
        return _obj


